# IRdMaterialGeneric Interface Reference

Generic Material interface and structures. More...

Inherits IUnknown.

List of all members.

## Public Member Functions
HRESULT | GetColorShaderItems ([out, retval] RtUlong *pdwItems)
HRESULT | GetColorItem (RtUlong dwIndex,[out] BSTR *pszName,[out] VARIANT *pItem)
HRESULT | QueryColorShader (LPCWSTR szKey,[out, retval] VARIANT *pItem)
HRESULT | SetColorItem (BSTR szKey, VARIANT vItem)
HRESULT | ClearColorShader ()
HRESULT | GetTransparencyShaderItems ([out, retval] RtUlong *pdwItems)
HRESULT | GetTransparencyItem (RtUlong dwIndex,[out] BSTR *pszName,[out] VARIANT *pItem)
HRESULT | QueryTransparencyShader (LPCWSTR szKey,[out, retval] VARIANT *pItem)
HRESULT | SetTransparencyItem (BSTR szKey, VARIANT vItem)
HRESULT | ClearTransparencyShader ()
HRESULT | GetReflectanceShaderItems ([out, retval] RtUlong *pdwItems)
HRESULT | GetReflectanceItem (RtUlong dwIndex,[out] BSTR *pszName,[out] VARIANT *pItem)
HRESULT | QueryReflectanceShader (LPCWSTR szKey,[out, retval] VARIANT *pItem)
HRESULT | SetReflectanceItem (BSTR szKey, VARIANT vItem)
HRESULT | ClearReflectanceShader ()
HRESULT | GetDisplacementShaderItems ([out, retval] RtUlong *pdwItems)
HRESULT | GetDisplacementItem (RtUlong dwIndex,[out] BSTR *pszName,[out] VARIANT *pItem)
HRESULT | QueryDisplacementShader (LPCWSTR szKey,[out, retval] VARIANT *pItem)
HRESULT | SetDisplacementItem (BSTR szKey, VARIANT vItem)
HRESULT | ClearDisplacementShader ()
HRESULT | SetDefaultMaterial ()
HRESULT | SetFallbackMaterial ()

## Detailed Description

Generic Material interface and structures.

General description of material used for material transfer.

## Member Function Documentation

HRESULT IRdMaterialGeneric::GetColorShaderItems | ( | [out, retval] RtUlong * | pdwItems | ) |

Get number of items stored inside color shader.

Parameters:

  | pdwItems | Total records in color shader

HRESULT IRdMaterialGeneric::GetColorItem | ( | RtUlong | dwIndex,
|  | [out] BSTR * | pszName,
|  | [out] VARIANT * | pItem |
| ) |  |  |

Get color shader item by index.

Parameters:

  | dwItems | Item index
  | pszName | Returned item key
  | pItem | Returned item data

HRESULT IRdMaterialGeneric::QueryColorShader | ( | LPCWSTR | szKey,
|  | [out, retval] VARIANT * | pItem |
| ) |  |  |

Query color shader by a key.

Parameters:

  | szKey | Shader key
  | pItem | Returned item if found.

HRESULT IRdMaterialGeneric::SetColorItem | ( | BSTR | szKey,
|  | VARIANT | vItem |
| ) |  |  |

Set color shader item.

Parameters:

  | szKey | Key of shader item to set
  | vItem | Item to set.

HRESULT IRdMaterialGeneric::ClearColorShader | ( |  | ) |

Clear all color shader items.

HRESULT IRdMaterialGeneric::GetTransparencyShaderItems | ( | [out, retval] RtUlong * | pdwItems | ) |

Get number of items stored inside transparency shader.

Parameters:

  | pdwItems | Total records in transparency shader

HRESULT IRdMaterialGeneric::GetTransparencyItem | ( | RtUlong | dwIndex,
|  | [out] BSTR * | pszName,
|  | [out] VARIANT * | pItem |
| ) |  |  |

Get transparency shader item by index.

Parameters:

  | dwItems | Item index
  | pszName | Returned item key
  | pItem | Returned item data

HRESULT IRdMaterialGeneric::QueryTransparencyShader | ( | LPCWSTR | szKey,
|  | [out, retval] VARIANT * | pItem |
| ) |  |  |

Query transparency shader by a key.

Parameters:

  | szKey | Shader key
  | pItem | Returned item if found.

HRESULT IRdMaterialGeneric::SetTransparencyItem | ( | BSTR | szKey,
|  | VARIANT | vItem |
| ) |  |  |

Set transparency shader item.

Parameters:

  | szKey | Key of shader item to set
  | vItem | Item to set.

HRESULT IRdMaterialGeneric::ClearTransparencyShader | ( |  | ) |

Clear all transparency shader items.

HRESULT IRdMaterialGeneric::GetReflectanceShaderItems | ( | [out, retval] RtUlong * | pdwItems | ) |

Get number of items stored inside reflectance shader.

Parameters:

  | pdwItems | Total records in reflectance shader

HRESULT IRdMaterialGeneric::GetReflectanceItem | ( | RtUlong | dwIndex,
|  | [out] BSTR * | pszName,
|  | [out] VARIANT * | pItem |
| ) |  |  |

Get reflectance shader item by index.

Parameters:

  | dwItems | Item index
  | pszName | Returned item key
  | pItem | Returned item data

HRESULT IRdMaterialGeneric::QueryReflectanceShader | ( | LPCWSTR | szKey,
|  | [out, retval] VARIANT * | pItem |
| ) |  |  |

Query reflectance shader by a key.

Parameters:

  | szKey | Shader key
  | pItem | Returned item if found.

HRESULT IRdMaterialGeneric::SetReflectanceItem | ( | BSTR | szKey,
|  | VARIANT | vItem |
| ) |  |  |

Set reflectance shader item.

Parameters:

  | szKey | Key of shader item to set
  | vItem | Item to set.

HRESULT IRdMaterialGeneric::ClearReflectanceShader | ( |  | ) |

Clear all reflectance shader items.

HRESULT IRdMaterialGeneric::GetDisplacementShaderItems | ( | [out, retval] RtUlong * | pdwItems | ) |

Get number of items stored inside displacement shader.

Parameters:

  | pdwItems | Total records in displacement shader

HRESULT IRdMaterialGeneric::GetDisplacementItem | ( | RtUlong | dwIndex,
|  | [out] BSTR * | pszName,
|  | [out] VARIANT * | pItem |
| ) |  |  |

Get displacement shader item by index.

Parameters:

  | dwItems | Item index
  | pszName | Returned item key
  | pItem | Returned item data

HRESULT IRdMaterialGeneric::QueryDisplacementShader | ( | LPCWSTR | szKey,
|  | [out, retval] VARIANT * | pItem |
| ) |  |  |

Query displacement shader by a key.

Parameters:

  | szKey | Shader key
  | pItem | Returned item if found.

HRESULT IRdMaterialGeneric::SetDisplacementItem | ( | BSTR | szKey,
|  | VARIANT | vItem |
| ) |  |  |

Set displacement shader item.

Parameters:

  | szKey | Key of shader item to set
  | vItem | Item to set.

HRESULT IRdMaterialGeneric::ClearDisplacementShader | ( |  | ) |

Clear all transparency shader items.

HRESULT IRdMaterialGeneric::SetDefaultMaterial | ( |  | ) |

Set material to default settings - simple white phong.

HRESULT IRdMaterialGeneric::SetFallbackMaterial | ( |  | ) |

Set material to fallback settings (missing material)